/*****************************************************************************/
/* gmath.h 								     */
/*****************************************************************************/

#ifndef	__GMATH_H_INCLUDED
#define	__GMATH_H_INCLUDED	1

/*****************************************************************************/


void *	matrix_alloc_gen(int nrow,int ncol,size_t msize);
void *	matrix_alloc(int d,size_t msize);
void 	matrix_free(void *vm);
void *	vector_alloc(int d,size_t msize);
void	vector_free(void *v);

#define	galois_2p32_matrix_alloc(n)	matrix_alloc((n),sizeof(uint32_t))
#define	galois_2p32_matrix_free(m)	matrix_free(m)
#define	galois_2p32_vector_alloc(n)	vector_alloc((n),sizeof(uint32_t))
#define	galois_2p32_vector_free(v)	vector_free(v)

int	galois_2p32_solve_gauss(uint32_t **a,uint32_t *b,int n);
int	galois_2p32_invert_gauss(uint32_t **a,int n);
int	galois_2p32_column_echelon(uint32_t **m,int nrow,int ncol);
int	galois_2p32_row_echelon(uint32_t **m,int nrow,int ncol);

/*****************************************************************************/

#endif

/*****************************************************************************/
